Idiomatic Phrases Game 成语接龙SPFA+map

Idiomatic Phrases Game

Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two given idioms. For every two adjacent idioms, the last Chinese character of the former idiom should be the same as the first character of the latter one. For each time, Tom has a dictionary that he must pick idioms from and each idiom in the dictionary has a value indicates how long Tom will take to find the next proper idiom in the final list. Now you are asked to write a program to compute the shortest time Tom will take by giving you the idiom dictionary.

InputThe input consists of several test cases. Each test case contains an idiom dictionary. The dictionary is started by an integer N (0 < N < 1000) in one line. The following is N lines. Each line contains an integer T (the time Tom will take to work out) and an idiom. One idiom consists of several Chinese characters (at least 3) and one Chinese character consists of four hex digit (i.e., 0 to 9 and A to F). Note that the first and last idioms in the dictionary are the source and target idioms in the game. The input ends up with a case that N = 0. Do not process this case. 
OutputOne line for each case. Output an integer indicating the shortest time Tome will take. If the list can not be built, please output -1.Sample Input

5
5 12345978ABCD2341
5 23415608ACBD3412
7 34125678AEFD4123
15 23415673ACC34123
4 41235673FBCD2156
2
20 12345678ABCD
30 DCBF5432167D
0

Sample Output

17
-1

题意:每个成语由至少三个字组成,每个字为四个16进制的数字(0~F)组成。两个成语首尾相接,消耗Tom对前一个成语的查询时间,求最小查询时间。思路:最短路问题,注意对建图的处理。map将成语的首尾字以数字点的形式存储。使用map前必须初始化。
#include<stdio.h>
#include<string.h>
#include<string>
#include<map>
#include<deque>
#include<vector>
#define MAX 2005
#define INF 0x3f3f3f3f
using namespace std;

map<string,int> mp;

struct Node{
    int v,w;
}node;
vector<Node> edge[MAX];
int dis[MAX],b[MAX],w[MAX],bg[MAX],ed[MAX];
int n;

void spfa(int k)
{
    int i;
    deque<int> q;
    for(i=1;i<=n;i++){
        dis[i]=INF;
    }
    memset(b,0,sizeof(b));
    b[k]=1;
    dis[k]=0;
    q.push_back(k);
    while(q.size()){
        int u=q.front();
        for(i=0;i<edge[u].size();i++){
            int v=edge[u][i].v;
            int w=edge[u][i].w;
            if(dis[v]>dis[u]+w){
                dis[v]=dis[u]+w;
                if(b[v]==0){
                    b[v]=1;
                    if(dis[v]>dis[u]) q.push_back(v);
                    else q.push_front(v);
                }
            }
        }
        b[u]=0;
        q.pop_front();
    }
}
int main()
{
    int m,u,v,i,j;
    char s[200],s1[200],s2[200];
    while(scanf("%d",&n)&&n!=0){
        m=0;
        for(i=1;i<=2002;i++){
            edge[i].clear();
            mp.clear();    //!!
        }
        for(i=1;i<=n;i++){
            scanf("%d%s",&w[i],s);
            strncpy(s1,s,4);
            strncpy(s2,s+strlen(s)-4,4);
            s1[4]=‘\0‘;s2[4]=‘\0‘;
            if(!mp[s1]) mp[s1]=++m;
            if(!mp[s2]) mp[s2]=++m;
            u=mp[s1];v=mp[s2];
            bg[i]=u;ed[i]=v;
        }
        for(i=1;i<=n;i++){
            for(j=1;j<=n;j++){
                if(i!=j&&ed[i]==bg[j]){
                    node.v=j;
                    node.w=w[i];
                    edge[i].push_back(node);
                }
            }
        }
        spfa(1);
        if(n==1||dis[n]==INF) printf("-1\n");
        else printf("%d\n",dis[n]);
    }
    return 0;
}
时间: 2024-08-23 23:32:21

Idiomatic Phrases Game 成语接龙SPFA+map的相关文章

HDU 1546 Idiomatic Phrases Game

成语接龙. 上一个的尾必须和下一个的首相同.注意:花费的时间是上一个. 一开始我就建图建错了. 比如第 i 个成语 与第 j 个成语, 第  i 个成语前面的时间为 t : 建图为 i -> j = t: 基友说这<图论算法理论.实现及应用>上有一样的题,我借来看了一下,发现它建图似乎有错误. 0->3 这条边的权值似乎错了. 反正我的建图是这样的 0->1=5;0->3=5; 1->2=5; 2->4=7; 3->4=15; 求 0 -> 4

Idiomatic Phrases Game(图论最短路)

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3504    Accepted Submission(s): 1182 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

zoj 1750 Idiomatic Phrases Game (dijkstra)

Idiomatic Phrases Game Time Limit: 2 Seconds      Memory Limit: 65536 KB Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should bui

ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra)

 ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra) 题意 : 给定一本字典,字典里有很多成语,要求从字典里的第一个成语开始,运用字典里的成语变到最后一个成语,变得过程就是成语接龙,后一个成语的第一个字必须有前一个成语的最后一个字相等,给定的成语是4位16进制位,每个成语前边跟的数字代表着找到这个成语之后再找到下个成语还需要t分钟 . 思路 : 将所有的成语看成一个点,如果找到下一个成语,就建一条有向边,然后用dijkstra求最短路. 1 #include

Idiomatic Phrases Game HDU 1546

Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two

hdu1546——Idiomatic Phrases Game

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2191    Accepted Submission(s): 712 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

hdu 1546 Idiomatic Phrases Game 最短路

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2283    Accepted Submission(s): 742 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

HDU 1546 Idiomatic Phrases Game(dijkstra+优先队列)

Idiomatic Phrases Game Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the li

ZOJ-2750 Idiomatic Phrases Game---Dijk最短路

题目链接: https://vjudge.net/problem/ZOJ-2750 题目大意: 给定一本字典,字典里有很多成语,要求从字典里的第一个成语开始,运用字典里的成语变到最后一个成语,变得过程就是成语接龙,后一个成语的第一个字必须有前一个成语的最后一个字相等,给定的成语是4位16进制数字,每个成语前边跟的数字代表着找到这个成语之后再找到下个成语还需要t分钟 .(这里是找到该成语后还需要时间t,才能找到下一个成语) 思路: 每个成语有前面四个字符和后面四个字符,如果第i个成语后面字符等于第